//-------------------------------------------------------------------------
//
// File Name: sm_stateController.h
//
// Copyright (c) 2007-2008, Jason Breti (http://breti.org/codegen)
// All rights reserved.
// This code is released under the BSD License, as specified in the
// license.txt file.
//-------------------------------------------------------------------------

#ifndef SM_STATECONTROLLER_H
#define SM_STATECONTROLLER_H

//-------------------------------------------------------------------------
#include "sm_events.h"
#include "sm_stateChart.h"
#include <string>

//-------------------------------------------------------------------------
class SM_StateController
{
public:

  //-----------------------------------------------------------------------
  SM_StateController ();

  //-----------------------------------------------------------------------
  ~SM_StateController();

  //-----------------------------------------------------------------------
  void initialize ();
  
  //-----------------------------------------------------------------------
  void triggerEvent (enum SM_EVENTS event);
  
protected:

private:
  //-----------------------------------------------------------------------
  // copy constructor not implemented
  SM_StateController( const SM_StateController& );

  // assignment operator not implemented
  SM_StateController& operator=( const SM_StateController& );
  
  SM_StateChart m_stateChart;
  
}; // SM_StateController

//-------------------------------------------------------------------------
#endif

